WordProcess1Frb proto :dword
WordProcess11Frb proto lpfs:dword,lptz:dword,nSize:dword
WordStructFill proto :dword,:dword


.code

WordProcess1Frb proc uses esi edi lpfs:dword
	LOCAL tmp[20]:dword
	LOCAL p,h:dword
	; lpfs Structure
	; header = txt1
	; lpmem file
	; lpmem line table
	; dword size
	; line count
	; lpsize string
	
	lea edi,tmp
	mov esi,lpfs
	
	xor edx,edx
	mov eax,[esi+16]
	mov ecx,8
	mul ecx
	add eax,4
	

	invoke GlobalAlloc,GMEM_ZEROINIT,eax
	mov [esi+20],eax
	invoke GlobalLock,eax
	mov [edi+20],eax
	
	; [esi+20] is a list of structur
	mov eax,[edi+20]
	mov ecx,[esi+16]
	mov [eax],ecx
 	
	; temporary memory structure
	; +0 ecx for loop count
	; +4 data
	; +8 counter for mwmory
	; +12 pointer to word
	; +16 length off word
	; +20 memori pointer
	
	; Loop for retrieving stucture.
	; number total
	; s1 offset size
	; s2 offset size
	; s3 offset size
	; sn offset size
	
	mov edx,eax						; edx = pointer structure
	mov ecx,[esi+16]				; ecx = linecount
	xor eax,eax
	inc eax
	mov [edi+8],eax					; edi+8 line position.
	loop_for_struct1:
	mov [edi],ecx
	mov [edi+4],edx
		invoke TextFromFile,[edi+8],lpfs
		invoke Word_Count,edx,eax
		mov ecx,eax
		
		cmp ecx,0
		jle no_word
		
		mov edx,[esi+20]
		mov edx,eax
		xor eax,eax
		inc eax
		mov [edi+24],eax
		loop_back:
		push ecx
		push edx
			invoke TextFromFile,[edi+8],lpfs
			invoke Word_position,[edi+24],edx,eax
			
			mov [edi+28],edx
			mov [edi+32],eax
			mov edx,[edi+20]
			mov ecx,[edi+24]
			
			mov eax,[edi+28]
			mov [edx+ecx*4],eax
						
		pop edx
		pop ecx
		
		inc dword ptr[edi+24]
		dec ecx
		jnz loop_back
		
		no_word:
	mov ecx,[edi]
	mov edx,[edi+4]
		
	inc dword ptr[edi+8]
	dec ecx
	jnz loop_for_struct1
	
	invoke GlobalUnlock,[edi+20]
	
		
	ret
WordProcess1Frb endp

WordProcess11Frb proc uses esi edi lpfs:dword,lptz:dword,nSize:dword
	LOCAL cntr,tc,wp:dword
	LOCAL buff[512]:dword
	LOCAL buff2[512]:dword
	
	cmp nSize,0
	jnz @f
		ret
	@@:
	
	lea edi,buff
	mov esi,lptz
	mov ecx,nSize
	xor edx,edx
	loop_ch:
		mov al,[esi+edx]
		mov [edi+edx],al
	inc edx
	dec ecx
	jnz loop_ch
	inc edx
	mov byte ptr[edi+edx],0
	invoke CharUpper,addr buff

	mov esi,lpfs
	
	xor eax,eax
	mov wp,eax
	inc wp
	mov cntr,eax
	inc cntr
	mov ecx,[esi+16]
	loop_main:
	mov tc,ecx
		invoke TextFromFile,cntr,lpfs		; Getlinelength from text file is very slow.
		invoke UM_Word_Count,lpfs,cntr
		mov ecx,[edx+12]
		mov ecx,eax
		cmp eax,0
		jz no_word
			xor eax,eax
			mov wp,eax
			inc wp
			loop_each_word:
			push ecx
			invoke TextFromFile,cntr,lpfs
			invoke GetWord,esi,cntr,wp
			
			mov eax,[edx+8]
			cmp eax,nSize
			jnz not_equal
				invoke BndStr,[edx+4],addr buff,nSize
				cmp eax,1
				jnz not_equal
					ret
		not_equal:
			pop ecx
		inc wp
		dec ecx
		jnz loop_each_word
		
		no_word:
		
	inc cntr
	mov ecx,tc
	dec ecx
	jnz loop_main
	
	oke:
	xor eax,eax
	dec eax
	ret
WordProcess11Frb endp

WordStructFill proc uses esi edi lpfs:dword,lpfs2:dword
	LOCAL l_cnt,w_cnt:dword
	
	mov esi,lpfs
	mov edi,lpfs2
	
	
	mov ecx,[edi+16]
	mov l_cnt,1
	loop_lines:
	push ecx
		invoke UM_Word_Count,lpfs2,l_cnt
		mov ecx,eax
		cmp ecx,0
		jz no_word
		mov w_cnt,1
		loop_word:
		push ecx
			invoke GetWord,lpfs2,l_cnt,w_cnt
			push edx
			invoke WordProcess11Frb,lpfs,[edx+4],[edx+8]
			pop edx
			cmp dword ptr[edx],'FFFF'
			jnz not_valid
				mov [edx],eax
			not_valid:
		pop ecx
		inc w_cnt
		dec ecx
		jnz loop_word
		no_word:
	pop ecx
	inc l_cnt
;	cmp l_cnt,300
;	ja assume_done
	dec ecx
	jnz loop_lines
	
	assume_done:
	ret
WordStructFill endp